#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>

#if defined(__WATCOMC__)
#  define foosym "foo_"
#  define barsym "bar_"
#elif defined(__BORLANDC__)
#  define foosym "_foo"
#  define barsym "_bar"
#else
#  define foosym "foo"
#  define barsym "bar"
#endif

#define DLERRCHECK(x) \
  do { \
    if (!(x)) { \
      fprintf(stderr, "Error: %s\n", dlerror()); \
      exit(1); \
    } \
  } while(0)

int zip = 0;

void main(int argc, char *argv[])
{
  void *liba, *libb;
  void (*foo)(void), (*bar)(void);

  DLERRCHECK((liba = dlopen("a.dll", RTLD_NOW)) != NULL);
  DLERRCHECK((libb = dlopen("b.dll", RTLD_NOW)) != NULL);
  DLERRCHECK((foo = (void (*)(void)) dlsym(liba, foosym)) != NULL);
  DLERRCHECK((bar = (void (*)(void)) dlsym(libb, barsym)) != NULL);
  foo();
  bar();
  DLERRCHECK(dlclose(liba) != -1);
  DLERRCHECK(dlclose(libb) != -1);
}

void baz(void);

void baz()
{
  printf("baz called; zip = %d\n", zip);
}
